-- Suppression des tables
DROP TABLE ETUDIANT;
DROP TABLE TUE;

-- Suppression des types complexes
DROP TYPE Personne;
DROP TYPE PrenomType;
DROP TYPE Type_UE;

-- Création d'un type pour la liste des prénoms
CREATE OR REPLACE TYPE PrenomType AS TABLE OF VARCHAR2(50);
/

-- Création du type Etudiant avec une table emboitée pour les prénoms
CREATE OR REPLACE TYPE Personne AS OBJECT (
    id NUMBER,
    nom VARCHAR2(100),
    prenoms PrenomType,
    dob DATE
);

-- Création d'une table Etudiants pour les objets etudiants
CREATE TABLE Etudiant OF Personne (
    CONSTRAINT PK_ETUDIANT PRIMARY KEY(id)
) NESTED TABLE prenoms STORE AS TablePrenoms;

-- Création d'une table UE pour les unités d'enseignement
CREATE OR REPLACE TYPE Type_UE AS OBJECT (
    id NUMBER,
    isOption NUMBER(1),
    nom VARCHAR2(30)
);

-- CREATE TABLE TUE OF UE;
CREATE TABLE TUE OF Type_UE(
    CONSTRAINT PK_TUE PRIMARY KEY(id),
    CONSTRAINT check_isOption CHECK (isOPtion BETWEEN 0 AND 1)
);

CREATE OR REPLACE TYPE Type_Cours AS OBJECT (
    id NUMBER,
    nomCours VARCHAR2(255),
    UE REF TUE,
    creneau NUMBER(4),
    etudiantsInscrits REF Etudiant,
    TDTP VARCHAR2(4),
    dateCours DATE
);

CREATE TABLE Cours OF Type_Cours(
    CONSTRAINT PK_COURS PRIMARY KEY(id)
);


-- Exemple d'insertion d'un etudiant avec plusieurs prénoms
INSERT INTO ETUDIANT VALUES (
    Personne(1, 'DEZETREE', PrenomType('Jérémy', 'Pascal', 'Alexis'), DATE '2003-03-08'));

INSERT INTO Etudiant VALUES (
    Personne(2, 'DELMASTRO', PrenomType('Adrien', 'Nello'), DATE '1998-04-06'));

INSERT INTO Etudiant VALUES (
    Personne(3, 'FLAMBARD', PrenomType('Clément', 'Jean-Marc', 'Gérard'), DATE '2000-01-28'));

INSERT INTO Etudiant VALUES (
    Personne(4, 'FURET', PrenomType('Julien', 'Sylvain', 'Maurice', 'Gérard'), DATE '2003-02-08'));

INSERT INTO TUE VALUES (
    Type_UE(1, 0, 'Maths'));

INSERT INTO Cours VALUES (
    Type_Cours(1, 'Maths', (SELECT REF(e) FROM TUE e WHERE e.))
);

-- Requête pour afficher les données
SELECT e.id, e.nom, p.*, e.dob
FROM Etudiant e, TABLE(e.prenoms) p;

SELECT * FROM Etudiant;

SELECT * FROM TUE;